/*
    This file is part of Posixcpp library.

    Posixcpp library is free software: you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public License
    as published by the Free Software Foundation, either version 3 of
    the License, or (at your option) any later version.

    Posixcpp library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with Posixcpp library. If not, see
    <http://www.gnu.org/licenses/>.
*/

#include "posix_io_fifo.hpp"
#include <sys/stat.h>

using posix::io::Fifo;

using namespace posix;
using namespace posix::io;

void Fifo::make() {
	POSIX_CALL_ASSERT_X( mkfifo(this->fileName().c_str(), 0666) == 0,
	    std::string("Unable to make fifo ").append(this->fileName()));
}
